unit savedoc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Web;

type
  TSvDocDlg = class(TForm)
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    Button1: TButton;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    Web1: TWeb;
    procedure Web1Context1(Sender: TObject; Context, Level1,
      Level2: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Web1Disconnect(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Buff : array[0..4096] of char;
    FileStream : TFileStream;
    procedure KickDownLoading;
  end;

var
  SvDocDlg: TSvDocDlg;

implementation

{$R *.DFM}

procedure TSvDocDlg.KickDownLoading;
begin
     FileStream := TFileStream.Create(SaveDialog1.FileName, fmCreate);
     Web1.Request(Buff, 4095, 1, 1, 1);
end;

procedure TSvDocDlg.Web1Context1(Sender: TObject; Context, Level1,
  Level2: Integer);
begin
     FileStream.Write(Buff, Web1.ActualRead);
     Web1.Request(Buff, 4095, 1, 1, 1);
     if Web1.DocLen = 0 then
        Label2.Caption := 'Read ' + IntToStr(FileStream.Size) + ' bytes.'
     else
     begin
        Label2.Caption := 'Read ' + IntToStr(FileStream.Size) + ' bytes of ' + IntToStr(Web1.DocLen);
        ProgressBar1.Position := MulDiv(FileStream.Size, 100, Web1.DocLen);
     end;

end;

procedure TSvDocDlg.Button1Click(Sender: TObject);
begin
     Web1.Abort;
     if Assigned(FileStream) then
        FileStream.Free;
     Close;
end;

procedure TSvDocDlg.Web1Disconnect(Sender: TObject);
begin
     if Assigned(FileStream) then
        FileStream.Free;
     Close;
end;

end.
