program Browser;

uses
  Forms,
  SysUtils,
  WinTypes,
  WinProcs,
  Controls,
  brow in 'brow.pas' {MainForm},
  Fsplash in 'Fsplash.pas' {Splash},
  proxyd in 'proxyd.pas' {Proxy},
  prev in 'prev.pas' {Preview},
  request in 'request.pas' {RForm},
  unkn in 'unkn.pas' {Unk},
  search in 'search.pas' {FomdDlg},
  source in 'source.pas' {SourceDlg},
  save in 'save.pas' {SaveDlg},
  prg in 'prg.pas' {PrgDlg},
  savedoc in 'savedoc.pas' {SvDocDlg};

{$R *.RES}

var
  StartTime  : TDateTime;
  ShowSplash : Boolean;

begin
  ShowSplash := True;
  Application.Initialize;

  try
    if ShowSplash then begin
      { Create the splash screen }
      Screen.Cursor := crHourGlass;

      Splash := TSplash.Create(Application);

      Splash.Show;
      Splash.Update;

  end;

  { Create the forms }
  Application.Title := 'Beeline SurfACE';
  if ShowSplash then
  begin

      { Wait for a few seconds }
      StartTime := Now;
      repeat
            Application.ProcessMessages;
      until Now-StartTime > 2.0/24.0/3600.0;

      { Hide the splash screen }
      Splash.Hide;
    end;

    Screen.Cursor := crDefault;

  finally
    if ShowSplash then
    begin
      { Free the splash screen }
      Screen.Cursor := crDefault;
      Splash.Free;
    end;
  end;
  { Run the application }
  Application.CreateForm(TMainForm, MainForm);
  Application.Run;
end.
