unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WebBrow, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    UpDown1: TUpDown;
    Edit1: TEdit;
    UpDown2: TUpDown;
    Edit2: TEdit;
    UpDown3: TUpDown;
    Edit3: TEdit;
    UpDown4: TUpDown;
    Edit4: TEdit;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    I1: TImage;
    I2: TImage;
    I3: TImage;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure UpDown2Changing(Sender: TObject; var AllowChange: Boolean);
    procedure UpDown3Changing(Sender: TObject; var AllowChange: Boolean);
    procedure UpDown4Changing(Sender: TObject; var AllowChange: Boolean);
    procedure ComboBox1Click(Sender: TObject);
    procedure WebBrowser1BackBitmap(Sender: TObject; Bitmap: TBitmap; Host,
      Path, Name: string; var AutoHandle: Boolean);
    procedure I1Click(Sender: TObject);
  private
    { Private declarations }
    BackIndex : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
   s : string;
begin
     S := '';
     s := s + '<HTML>';
     s := s + '<HEAD>';
     s := s + '</HEAD>';
     s := s + '<BODY BACKGROUND="bg4.jpg">';
     s := s + '<CENTER>';
     s := s + '<H1><BLINK>TransCom WaveTools</BLINK></H1>';
     s := s + '<H2>Heading Size Two</H2>';
     s := s + '<TABLE BORDER=1>';
     s := s + '<TR>';
     s := s + '<TD>';
     s := s + 'First Cell';
     s := s + '</TD>';
     s := s + '<TD>';
     s := s + 'Second Cell';
     s := s + '</TD>';
     s := s + '</TR>';
     s := s + '<TR>';
     s := s + '<TD>';
     s := s + 'Third Cell';
     s := s + '</TD>';
     s := s + '<TD>';
     s := s + 'Fourth Cell';
     s := s + '</TD>';
     s := s + '</TR>';
     s := s + '</TABLE></CENTER>';
     s := s + '</BODY>';
     s := s + '</HTML>';

     Combobox1.Items := Screen.Fonts;
     Edit1.Text := IntToStr(WebBrowser1.Head1);
     Edit2.Text := IntToStr(WebBrowser1.Head2);
     Edit3.Text := IntToStr(WebBrowser1.CellPadding);
     Edit4.Text := IntToStr(WebBrowser1.CellSpacing);
     Combobox1.ItemIndex := Combobox1.Items.IndexOf(WebBrowser1.FontProportional.Name);

     BackIndex := 1;

     WebBrowser1.Source := s;
     WebBrowser1.ParseBuffer;
end;

procedure TForm1.UpDown1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
     WebBrowser1.Head1 := StrToInt(Edit1.Text);
     WebBrowser1.ParseBuffer;
end;

procedure TForm1.UpDown2Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
     WebBrowser1.Head2 := StrToInt(Edit2.Text);
     WebBrowser1.ParseBuffer;
end;

procedure TForm1.UpDown3Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
     WebBrowser1.CellPadding := StrToInt(Edit3.Text);
     WebBrowser1.ParseBuffer;
end;

procedure TForm1.UpDown4Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
     WebBrowser1.CellSpacing := StrToInt(Edit4.Text);
     WebBrowser1.ParseBuffer;
end;

procedure TForm1.ComboBox1Click(Sender: TObject);
begin
     WebBrowser1.FontProportional.Name := Combobox1.Items[Combobox1.ItemIndex];
     WebBrowser1.ParseBuffer;
end;

procedure TForm1.WebBrowser1BackBitmap(Sender: TObject; Bitmap: TBitmap;
  Host, Path, Name: string; var AutoHandle: Boolean);
var
   img : TImage;
begin
     img := TImage(FindComponent('I'+IntToStr(BackIndex)));
     Bitmap.Assign(img.Picture.Bitmap);
     AutoHandle := False;
end;

procedure TForm1.I1Click(Sender: TObject);
begin
     BackIndex := StrToInt(Copy(TImage(Sender).Name,2,1));
     WebBrowser1.ParseBuffer;
end;

end.
